Program Stelutza;

Type Star = Array[1..100] Of String;

Var S: Star;
    Fin, Fout: Text;
    n: Integer;
    Best: LongInt;


Procedure Read_Data;
Var i: Integer;
Begin
  Assign(Fin, 'stea.in'); Reset(Fin);
  ReadLn(Fin, n);
  For i := 1 To n Do ReadLn(Fin, S[i]);
  Close(Fin);
End;

Procedure Find_Solution;
Var i, j, jj, temp, lin, col, FromCol, ToCol: Integer;
    OK: Boolean;
Begin
  For i := 1 To n Do {search the triangles with the peak up}
    For j := i To 2*n-i Do {search a possible peak of triangle}
      If S[i, j] = '-' Then
        Begin
          OK := TRUE;
          lin := i; col := j; {it is a possible peak}
          temp := 0;          {number of lines for the triangle}
          While OK Do
            Begin
              lin := lin+1; temp := temp+1;  {one more line}
              FromCol := col-temp; ToCol := Col+temp; {verify the characters from FromCol to ToCol in this line}
              jj := FromCol;
              While (jj<=ToCol) And OK Do
                Begin
                  If S[lin, jj] <>'-' Then
                    OK := FALSE;             {wrong character}
                  jj := jj+1
                End;
            End;
          If temp>Best Then                  {it is more than the Best find until now?}
            Best := temp;
          If Best=n*n Then Exit
        End;
  For i := n DownTo 1 Do   {same procedure for the triangles with the peak down}
    For j := i To 2*n-i Do
      If S[i, j] = '-' Then
        Begin
          OK := TRUE;
          lin := i; col := j;
          temp := 0;
          While OK Do
            Begin
              lin := lin-1; temp := temp+1;
              FromCol := col-temp; ToCol := Col+temp;
              jj := FromCol;
              While (jj<=ToCol) And OK Do
                Begin
                  If S[lin, jj] <>'-' Then
                    OK := FALSE;
                  jj := jj+1
                End;
            End;
          If temp>Best Then
            Best := temp;
          If Best=n*n Then Exit
        End;
End;

Begin
  Assign(Fout, 'stea.out'); ReWrite(Fout);
  Read_Data;
  Find_Solution;
  WriteLn(Fout, Best*Best);
  Close(Fout);
End.