#include<stdio.h>
#include<ctype.h>

#define InFile  "ceas.in"
#define OutFile "ceas.out"

long t;
int c[4][8];

void read()
{
  FILE *in=fopen(InFile, "r");
  flushall();
  char ch[10], car_sf;
  int i, j;
  for(i=0; i<4; i++)
   {
      fgets(ch, 9, in);
      for(j=0; j<8; j++)
	   if(ch[j]== 'x' || ch[j] == ' ') c[i][j]=0;
	     else c[i][j]=1;
      fscanf(in, "%c", &car_sf);
   }
  fscanf(in, "%ld", &t);
}

long valoare(int col)
{
  int j, i, cif;
  long x=0;
  for(j=col; j<col+2; j++)
   { cif = 0;
     for(i=0; i<4; i++)
	cif=cif*2+c[i][j];
     x=x*10+cif;
   }
  return x;
}

void  matrice(int col, int cif)
{ int i;
  for(i=3; i>=0; i--)
    { c[i][col] = cif%2;
      cif /= 2;
    }
}

void solve()
{
  unsigned long h, m, s, zs;
  h  = valoare(0);
  m  = valoare(2);
  s  = valoare(4);
  zs = valoare(6);
  zs += t;
  s = s + zs/100;  zs %= 100;
  m = m + s/60;    s %= 60;
  h = h + m/60;    m %= 60;
  if(h>=24) h %= 24 ;
  if( h/10 == 0 ) c[3][0] = c[2][0] = 0;
    else if(h/10 == 1) c[3][0] = 1, c[2][0] = 0;
	 else c[3][0] = 0, c[2][0] = 1;
  h %= 10;
  matrice ( 1, h);
  matrice ( 2, m/10);
  matrice ( 3, m%10);
  matrice ( 4, s/10);
  matrice ( 5, s%10);
  matrice ( 6, zs/10);
  matrice ( 7, zs%10);
}

void write()
{
  FILE * out = fopen(OutFile, "w");
  for(int i=0; i<4; i++)
    { for(int j=0; j<8; j++)
	 if((j==0 || j==2 || j==4) && (i==0)) fprintf(out, " ");
	 else
	    if(i==1 && j==0) fprintf(out, " ");
	    else
	       if(c[i][j]==1) fprintf(out, "o");
	       else fprintf(out, "x");
      fprintf(out,"\n");
    }
  fclose(out);
}

int main()
{
  read();
  solve();
  write();

  return 0;
}
